﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TMPro;
using System.Linq;

public class EnjoymentManager : MonoBehaviour
{

    public Slider EnjoymentSlider = null;
    public TextMeshProUGUI AlivePercentDisplay = null;
    public TextMeshProUGUI DeltaDisplay = null;

    public GameObject YouWinPanel = null;
    public GameObject YouLosePanel = null;

    // Start is called before the first frame update
    void Start()
    {
        MaxEnjoymentLevel = GameState.Instance.NextLevelToPlay.HappinessTarget;
        EnjoymentSlider.maxValue = MaxEnjoymentLevel;
        CurrentEnjoymentLevel = MaxEnjoymentLevel / 10;
    }

    public int CurrentEnjoymentLevel = 0;
    public int MaxEnjoymentLevel = 7000;

    // Update is called once per frame
    void FixedUpdate()
    {
        Rose[] roses = FindObjectsOfType<Rose>();
        int deadRoses = roses.Count(rose => !rose.Alive);
        float AlivePercentage = (1.0f - ((float)deadRoses / roses.Length)) * 100.0f;

        AlivePercentDisplay.text = AlivePercentage.ToString("#") + "%";

        //(AlivePercentage >= 89.5f)
        //{
        //    CurrentEnjoymentLevel += 2;
        //    DeltaDisplay.text = ">> <sprite=0><sprite=0> >>";
        //}

        if (AlivePercentage >= 69.5f)
        {
            CurrentEnjoymentLevel += 1;
            DeltaDisplay.text = "> <sprite=0> >";
        }
        else if (AlivePercentage >= 49.5f)
        {
            CurrentEnjoymentLevel -= 1;
            DeltaDisplay.text = "< <sprite=15> <";
        }
        else if (AlivePercentage >= 39.5f)
        {
            CurrentEnjoymentLevel -= 2;
            DeltaDisplay.text = "<< <sprite=15><sprite=15> <<";
        }
        else
        {
            CurrentEnjoymentLevel -= 5;
            DeltaDisplay.text = "<<<<< <sprite=10><sprite=10> <<<<<";
        }
    }

    private void Update()
    {
        EnjoymentSlider.value = CurrentEnjoymentLevel;

        if (CurrentEnjoymentLevel > MaxEnjoymentLevel)
        {
            YouWinPanel.SetActive(true);
            if (GameState.Instance.HighestUnlockedLevel < GameState.Instance.NextLevelToPlay.UnlocksLevel)
            { 
                GameState.Instance.HighestUnlockedLevel = GameState.Instance.NextLevelToPlay.UnlocksLevel;
                GameState.Instance.Save();
            }
        }
        else if (CurrentEnjoymentLevel < 0)
        {
            YouLosePanel.SetActive(true);
        }
    }

    public void OnEndGamePanelButtonClicked()
    {
        UnityEngine.SceneManagement.SceneManager.LoadScene("CampaignMenu");
    }
}
