﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[CreateAssetMenu(menuName = "Level Information")]
public class LevelInformation : ScriptableObject
{
    [Header("First Speaker")]
    public string FirstSpeakerPortrait = "";
    public string FirstSpeakerName = "";
    [TextArea()]
    public string FirstSpeakerLine = "";
    [Header("Second Speaker")]
    public string SecondSpeakerPortrait = "";
    public string SecondSpeakerName = "";
    [TextArea()]
    public string SecondSpeakerLine = "";

    [Header("Board")]
    public float OrthoCameraSize = 4.5f;
    public int BoardWidth = 6;
    public int BoardHeight = 6;
    public RepairPiece[] RepairPieces = null;
    public int[] HoleSizes = null;

    [Header("Difficulty")]
    public int[] HoleCreationIntervals = { 5, 5, 5, 5, 5, 5 };
    public int HappinessTarget = 3500;
    public bool IsTutorialLevel = false;
    public int UnlocksLevel = 2;
}
