﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Rose : MonoBehaviour
{
    [SerializeField]
    private GameObject AliveGeo = null;
    [SerializeField]
    private GameObject DeadGeo = null;

    public GameObject DiedFX = null;
    public GameObject RebornFX = null;

    public bool Alive
    {
        get
        {
            return _alive;
        }
        set
        {
            if (_alive != value)
            {
                _alive = value;

                if (_alive)
                {
                    // Come back to life
                    GameObject fx = Instantiate(RebornFX, transform.position, Quaternion.identity);
                    //ParticleSystem ps = fx.GetComponent<ParticleSystem>();
                    //var main = ps.main;
                    //main.startColor = _flowerColor;
                    StartCoroutine(DeadToAliveTransition());

                }
                else
                {
                    // Play Died particle
                    GameObject fx = Instantiate(DiedFX, transform.position, Quaternion.identity);
                    ParticleSystem ps = fx.GetComponent<ParticleSystem>();
                    var main = ps.main;
                    main.startColor = _flowerColor;

                    StartCoroutine(AliveToDeadTransition());
                }
            }
        }
    }
    private bool _alive = true;

    private IEnumerator AliveToDeadTransition()
    {
        Color startColor = _flowerColor;
        Color endColor = new Color(0.16f, 0.21f, 0.23f);
        float startTime = Time.time;

        float t = Time.time - startTime;

        MeshRenderer roseRenderer = AliveGeo.GetComponent<MeshRenderer>();
        while (t < 1.0f && !_alive)
        {
            roseRenderer.material.SetColor("_Tint", Color.Lerp(startColor, endColor, t));

            yield return null;
            t = Time.time - startTime;
        }

        AliveGeo.SetActive(_alive);
        roseRenderer.material.SetColor("_Tint", startColor);
        DeadGeo.SetActive(!_alive);
    }

    private IEnumerator DeadToAliveTransition()
    {
        Color startColor = new Color(0.16f, 0.21f, 0.23f);
        Color endColor = _flowerColor;
        float startTime = Time.time;

        float t = Time.time - startTime;

        AliveGeo.SetActive(_alive);
        DeadGeo.SetActive(!_alive);

        MeshRenderer roseRenderer = AliveGeo.GetComponent<MeshRenderer>();

        while (t < 1.0f && _alive)
        {
            roseRenderer.material.SetColor("_Tint", Color.Lerp(startColor, endColor, t));

            yield return null;
            t = Time.time - startTime;
        }

        roseRenderer.material.SetColor("_Tint", endColor);
    }

    public Color FlowerColor
    {
        get
        {
            return _flowerColor;
        }
        set
        {
            _flowerColor = value;
            MeshRenderer roseRenderer = AliveGeo.GetComponent<MeshRenderer>();
            roseRenderer.material.SetColor("_Tint", _flowerColor);
        }
    }
            
    private Color _flowerColor;
}
