﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Tutorial : MonoBehaviour
{
    public GameObject[] ObjsToHideOnTutorial = null;
    public GameObject WaterPatternPanel = null;
    public GameObject WateringTipPanel = null;

    bool TutorialComplete = false;

    // Start is called before the first frame update
    void Start()
    {
        if (GameState.Instance.NextLevelToPlay.IsTutorialLevel)
        {
            foreach (GameObject o in ObjsToHideOnTutorial)
            {
                o.SetActive(false);
            }

            WaterPatternPanel.SetActive(true);
            WateringTipPanel.SetActive(false);
        }
    }

    // Update is called once per frame
    void Update()
    {
        if (GameState.Instance.NextLevelToPlay.IsTutorialLevel && !TutorialComplete)
        {
            if (WaterPatternPanel.activeSelf)
            {
                if (GetComponent<ConveyorManager>().SelectedRepairPiece != null)
                {
                    WaterPatternPanel.SetActive(false);
                    WateringTipPanel.SetActive(true);
                }
            }
            else
            {
                if (GetComponent<ConveyorManager>().SelectedRepairPiece == null)
                {
                    WateringTipPanel.SetActive(false);
                    TutorialComplete = true;
                }
            }
        }
        
    }
}
