﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class WateringCan : MonoBehaviour
{
    public int MaximumWater = 900;
    public int CurrentWater = 0;
    public int WaterPerCharge = 300;

    public Slider WaterSlider = null;

    public GameObject[] ChargeIndicators = null;

    public int ChargesAvailable
    {
        get
        {
            return CurrentWater / WaterPerCharge;
        }
    }



    // Start is called before the first frame update
    void Start()
    {
        WaterSlider.maxValue = MaximumWater;
        CurrentWater = 180;
        
    }

    void FixedUpdate()
    {
        CurrentWater += 1;
        if (CurrentWater > MaximumWater)
            CurrentWater = MaximumWater;
    }

    public void UseCharge()
    {
        CurrentWater -= WaterPerCharge;
    }

    // Update is called once per frame
    void Update()
    {
        WaterSlider.value = CurrentWater;
        for (int i = 0; i < ChargeIndicators.Length; i++)
        {
            ChargeIndicators[i].SetActive(ChargesAvailable > i);
        }
    }
}
