﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class WonderGroButton : MonoBehaviour
{
    public RepairPiece HostedPiece
    {
        set
        {
            _hostedPiece = value;
            RenderHostedPiece();
        }

        get
        {
            return _hostedPiece;
        }
    }
    private RepairPiece _hostedPiece = null;
    public Image PieceRepresentation = null;

    public void RenderHostedPiece()
    {
        HexGrid renderGrid = new HexGrid(8);

        foreach(AxialCoordinate ac in _hostedPiece.Pieces)
        {
            Image newPiece = GameObject.Instantiate(PieceRepresentation, transform);
            Vector3 dotPosition = renderGrid.WorldPositionFromAxialPosition(ac);
            Vector3 UIPosition = new Vector3(dotPosition.x, dotPosition.z, 0.0f);
            RectTransform rt = newPiece.GetComponent<RectTransform>();
            rt.anchoredPosition = UIPosition;
        }
    }

    // Start is called before the first frame update
    void Start()
    {
        
    }
}
